!> @brief Module ffor global variables
!! @author     LABREN
!! @version    1.0
!! @date       2020
!-------------------------------------------------------------------------------
MODULE BRconstants
  integer, parameter:: dp=kind(0.d0)
END MODULE BRconstants

!-------------------------------------------------------------------------------
!> @brief Module for interfaces
!! @author     LABREN
!! @version    1.0
!! @date       2020
!-------------------------------------------------------------------------------
MODULE BRinterface
  use BRconstants

INTERFACE
  SUBROUTINE GLOD8A(NDIA,XLON,YLAT,XHOR,TCLEAR,TCLOUD,GLOBAL,XXKT,COSZEN,CEFF,PEFF,TCDL0)
    INTEGER, INTENT(IN)::NDIA
    DOUBLE PRECISION, INTENT(IN)::XLON,YLAT, XHOR
    DOUBLE PRECISION, intent(in) :: TCLEAR,TCLOUD
    DOUBLE PRECISION, intent(out) :: GLOBAL,XXKT,COSZEN
    DOUBLE PRECISION, intent(in), optional :: CEFF,PEFF,TCDL0
  END SUBROUTINE GLOD8A
END INTERFACE

INTERFACE
  SUBROUTINE SWTR8A (XLON,YLAT,NDIA,XHOR,TCLEAR,TCLOUD,RADGLO,CEFF,PEFF,TCDL0)
    INTEGER, INTENT(IN)::NDIA
    DOUBLE PRECISION, INTENT(IN)::XLON,YLAT, XHOR
    DOUBLE PRECISION, intent(in) :: TCLEAR,TCLOUD
    DOUBLE PRECISION,DIMENSION(5), intent(out) ::RADGLO
    DOUBLE PRECISION, intent(in), optional :: CEFF,PEFF,TCDL0
  END SUBROUTINE SWTR8A
END INTERFACE

INTERFACE
  SUBROUTINE DIFFUSE1(GLOBAL, XXKT,COSZEN,TDIRCLEAR, DIF, DNI,CEFF,PEFF)
    DOUBLE PRECISION, INTENT(IN)::		GLOBAL,XXKT	,COSZEN	,TDIRCLEAR
    DOUBLE PRECISION, INTENT(OUT)::		DIF,	DNI
    DOUBLE PRECISION, intent(in), optional :: CEFF,PEFF
END SUBROUTINE DIFFUSE1
END INTERFACE
!--------------------------------------------
contains
subroutine handler_alloc(IERR,my_errmsg)
  integer, intent (in) :: IERR
  CHARACTER(256), intent (in)  :: my_errmsg
  write(*,*) 'Failed to allocate with stat = ', my_stat, ' and errmsg '//trim(my_errmsg)
end subroutine handler_alloc
!--------------------------------------------
subroutine handler_dealloc(IERR,my_errmsg)
  integer, intent (in) :: IERR
  CHARACTER(256), intent (in)  :: my_errmsg
  write(*,*) 'Failed to allocate with stat = ', my_stat, ' and errmsg '//trim(my_errmsg)
end subroutine handler_dealloc
END MODULE BRinterface
