!calculo minimo new
!ifort -o extraer_ij extraer_ij.f90 -L/opt/libs/intel/lib -lhdf5 -lhdf5_hl -lz -lsz -lcurl -lnetcdff -lnetcdf -I/opt/intel/compilers_and_libraries_2019.4.243/linux/mkl/include -I/opt/libs/intel/include

 program extraer_recorte
 use netcdf
 use gradevars

 TYPE :: point_defs
     CHARACTER(len=30) :: NOME
     DOUBLE PRECISION :: LATI
     DOUBLE PRECISION :: LONGI
     INTEGER :: GRADI
     INTEGER :: GRADJ
 END TYPE point_defs
 INTEGER, PARAMETER :: num_points=4
 TYPE(point_defs), DIMENSION(num_points) :: point

 CHARACTER*200 :: ncdf
 INTEGER::ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in
 integer :: lat_dimid, lon_dimid, lat_varid, lon_varid, vi_varid, ang_sol_varid, ang_sat_varid, ang_sat_sol_varid
 integer:: nlat, nlon

 DOUBLE PRECISION, dimension(:), allocatable ::lats, lons
 INTEGER:: i, j, k
 INTEGER :: Imin_guess, Jmin_guess
 DOUBLE PRECISION :: diflat, diflon
 !Cell size in lat lon
 DOUBLE PRECISION, PARAMETER :: cellsizelat=0.05, cellsizelon=0.03

 ! Example file corresponding with full size domain to get lats and lons
 ncdf='/dados/estudo_caso_ICEM/modelo2015/aug/images/netcdf/sat2142015.1500.nc'


 call check(nf90_open(ncdf, nf90_nowrite, ncid) )
 call check(nf90_inquire(ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in))

 call check(nf90_inq_varid(ncid,"latitude", lat_varid))
 call check(nf90_inq_varid(ncid,"longitude", lon_varid))
 call check(nf90_inq_varid(ncid,"imagem_ir", ir_varid))
 call check(nf90_inq_varid(ncid,"imagem_vi", vi_varid))
 call check(nf90_inq_varid(ncid,"angulo_sol", ang_sol_varid))
 call check(nf90_inq_varid(ncid,"angulo_satelite", ang_sat_varid))
 call check(nf90_inq_varid(ncid,"angulo_satelite_sol", ang_sat_sol_varid))

 call check(nf90_inq_dimid(ncid, "latitude", lat_dimid))
 call check(nf90_inq_dimid(ncid, "longitude", lon_dimid))

 call check(nf90_inquire_dimension(ncid,lat_dimid,len=ilat))
 call check(nf90_inquire_dimension(ncid,lon_dimid,len=ilon))

 allocate(lats(ilat))
 allocate(lons(ilon))

 call check(nf90_get_var(ncid,lat_varid,lats))
 call check(nf90_get_var(ncid,lon_varid,lons))

 call check(nf90_close(ncid))
 ! Closing example file

 !Using centers to calculate domain
 OPEN(UNIT=30,FILE='point_config.dat')

OPEN(UNIT=20,FILE='pointslatlon.csv')
DO k=1, num_points
 READ(20,*) point(k)%NOME, point(k)%LATI, point(k)%LONGI
 print*,point(k)%NOME, point(k)%LATI, point(k)%LONGI
 deltalat=deltalatkm*1000/(Mradius(point(k)%LATI)*(pi/180.0D0))
 deltalon=deltalonkm*1000/(Nradius(point(k)%LATI)*cos(point(k)%LATI*(pi/180.0D0))*(pi/180.0D0))

 Imin_guess=int((point(k)%LONGI-lons(1))/cellsizelon)
 Jmin_guess=int((lats(1)-point(k)%LATI)/cellsizelat)

 if (abs(lons(Imin_guess)-point(k)%LONGI).LE.cellsizelon/2.D0) then
   point(k)%GRADI=i-Imin_guess
 elseif (abs(lons(Imin_guess+1)-point(k)%LONGI).LE.abs(lons(Imin_guess-1)-point(k)%LONGI)) then
   do i=Imin_guess, Imin_guess+10
     if (abs(lons(i)-point(k)%LONGI).LE.cellsizelon/2.D0) then
       point(k)%GRADI=i-IMIN
       EXIT
     endif
   enddo
 else
   do i=Imin_guess-10, Imin_guess
     if (abs(lons(i)-point(k)%LONGI).LE.cellsizelon/2.D0) then
       point(k)%GRADI=i-IMIN
       EXIT
     endif
   enddo
 endif

 if (abs(lats(Jmin_guess)-point(k)%LATI).LE.cellsizelat/2.D0) then
   point(k)%GRADJ=i-Jmin_guess
 elseif (abs(lats(Jmin_guess+1)-point(k)%LATI).LE.abs(lats(Jmin_guess-1)-point(k)%LATI)) then
   do i=Jmin_guess, Jmin_guess+10
     if (abs(lats(i)-point(k)%LATI).LE.cellsizelat/2.D0) then
       point(k)%GRADJ=i-JMIN
       EXIT
     endif
   enddo
 else
   do i=Jmin_guess-10, Jmin_guess
     if (abs(lats(i)-point(k)%LATI).LE.cellsizelat/2.D0) then
       point(k)%GRADJ=i-JMIN
       EXIT
     endif
   enddo
  endif
enddo
close(20)

do k=1,num_points
   write(30,*)'!',point(k)%NOME
   write(30,*)'  INTEGER, PARAMETER :: IMIN =',point(k)%GRADI
   write(30,*)'  INTEGER, PARAMETER :: JMIN =',point(k)%GRADJ
end do




   contains
  !!--------------------------------------------
  DOUBLE PRECISION function Nradius(phi)
  !!Radius of curvature in the prime vertical to calculate deltalon
    double precision, intent(in)::phi !in degrees
    DOUBLE PRECISION, PARAMETER :: eq_r=6378137.0, pi=3.1415927,e2=0.00669437999014

    Nradius=eq_r/sqrt(1-e2*(sin(phi*(pi/180.0D0)))**2)
    RETURN
  end function Nradius

  !!--------------------------------------------
  DOUBLE PRECISION function Mradius(phi)
  !!Radius of curvature in the meridian to calculate deltalat
    double precision, intent(in)::phi
    DOUBLE PRECISION, PARAMETER :: eq_r=6378137.0, pi=3.1415927,e2=0.00669437999014

    Mradius=eq_r/sqrt(1-e2*(sin(phi*(pi/180.0D0)))**2)

    RETURN
  end function Mradius
  !!--------------------------------------------
   subroutine check(status)
     integer, intent (in) :: status
     if(status /= nf90_noerr) then
       print *, trim(nf90_strerror(status))
       stop 2
     end if
   end subroutine check
end program
