!calculo minimo new
!ifort -o extraer_recorte extraer_recorte.f90 -L/opt/libs/intel/lib -lhdf5 -lhdf5_hl -lz -lsz -lcurl -lnetcdff -lnetcdf -I/opt/intel/compilers_and_libraries_2019.4.243/linux/mkl/include -I/opt/libs/intel/include

 program extraer_recorte
 use netcdf

  TYPE :: subdomain_defs
     CHARACTER(len=30) :: NOME
     DOUBLE PRECISION :: LATI
     DOUBLE PRECISION :: LONGI
     DOUBLE PRECISION :: LATI_LOWERLEFT
     DOUBLE PRECISION :: LONGI_LOWERLEFT
     DOUBLE PRECISION :: LATI_UPPERRIGHT
     DOUBLE PRECISION :: LONGI_UPPERRIGHT
     INTEGER :: GRADI
     INTEGER :: GRADJ
     INTEGER :: IMIN
     INTEGER :: IMAX  ! VERIFICAR, IMAX = IMIN + IRANGE -1
     INTEGER :: IRANGE
     INTEGER :: JMIN
     INTEGER :: JMAX
     INTEGER :: JRANGE  ! VERIFICAR, JMAX = JMIN + JRANGE -1
 END TYPE subdomain_defs
 INTEGER, PARAMETER :: num_subdomains=1
 TYPE(subdomain_defs), DIMENSION(num_subdomains) :: subdomain

 CHARACTER*200 :: ncdf
 INTEGER::ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in
 integer :: lat_dimid, lon_dimid, lat_varid, lon_varid, vi_varid, ang_sol_varid, ang_sat_varid, ang_sat_sol_varid
 integer:: nlat, nlon

 DOUBLE PRECISION, dimension(:), allocatable ::lats, lons

 INTEGER:: i, j, k
 DOUBLE PRECISION, PARAMETER :: pi=3.1415927
 DOUBLE PRECISION :: deltalat, deltalon,  phi
 INTEGER :: Imin_guess, Jmin_guess
 DOUBLE PRECISION :: diflat, diflon
!Size in km of subdomain when using centers
 DOUBLE PRECISION, PARAMETER :: deltalatkm=300.D0, deltalonkm=300.D0
 !Cell size in lat lon
 DOUBLE PRECISION, PARAMETER :: cellsizelat=0.05, cellsizelon=0.03
 INTEGER, PARAMETER :: USECENTER = 0

 ! Example file corresponding with full size domain to get lats and lons
 ncdf='sat2142015.1500.nc'


 call check(nf90_open(ncdf, nf90_nowrite, ncid) )
 call check(nf90_inquire(ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in))

 call check(nf90_inq_varid(ncid,"latitude", lat_varid))
 call check(nf90_inq_varid(ncid,"longitude", lon_varid))
 call check(nf90_inq_varid(ncid,"imagem_ir", ir_varid))
 call check(nf90_inq_varid(ncid,"imagem_vi", vi_varid))
 call check(nf90_inq_varid(ncid,"angulo_sol", ang_sol_varid))
 call check(nf90_inq_varid(ncid,"angulo_satelite", ang_sat_varid))
 call check(nf90_inq_varid(ncid,"angulo_satelite_sol", ang_sat_sol_varid))

 call check(nf90_inq_dimid(ncid, "latitude", lat_dimid))
 call check(nf90_inq_dimid(ncid, "longitude", lon_dimid))

 call check(nf90_inquire_dimension(ncid,lat_dimid,len=ilat))
 call check(nf90_inquire_dimension(ncid,lon_dimid,len=ilon))

 allocate(lats(ilat))
 allocate(lons(ilon))

 call check(nf90_get_var(ncid,lat_varid,lats))
 call check(nf90_get_var(ncid,lon_varid,lons))

 call check(nf90_close(ncid))
 ! Closing example file

 !Using centers to calculate domain
 OPEN(UNIT=30,FILE='subdomain_config.dat')

 IF (USECENTER.EQ.1)THEN

    OPEN(UNIT=20,FILE='subdomain_centers.csv')
    DO k=1, num_subdomains
       READ(20,*) subdomain(k)%NOME, subdomain(k)%LATI, subdomain(k)%LONGI
       print*,subdomain(k)%NOME, subdomain(k)%LATI, subdomain(k)%LONGI
       deltalat=deltalatkm*1000/(Mradius(subdomain(k)%LATI)*(pi/180.0D0))
       deltalon=deltalonkm*1000/(Nradius(subdomain(k)%LATI)*cos(subdomain(k)%LATI*(pi/180.0D0))*(pi/180.0D0))

       subdomain(k)%IRANGE=int(deltalon/cellsizelon)
       subdomain(k)%JRANGE=int(deltalat/cellsizelat)
       print*,deltalat, deltalon, subdomain(k)%IRANGE, subdomain(k)%JRANGE

       Imin_guess=int((subdomain(k)%LONGI-lons(1))/cellsizelon)
       Jmin_guess=int((lats(1)-subdomain(k)%LATI)/cellsizelat)
       print*,(subdomain(k)%LONGI-lons(1)),lons(1)


       if (abs(lons(Imin_guess)-subdomain(k)%LONGI).LE.cellsizelon/2.D0) then
         subdomain(k)%IMIN=Imin_guess
       elseif (abs(lons(Imin_guess+1)-subdomain(k)%LONGI).LE.abs(lons(Imin_guess-1)-subdomain(k)%LONGI)) then
         do i=Imin_guess, Imin_guess+10
           if (abs(lons(i)-subdomain(k)%LONGI).LE.cellsizelon/2.D0) then
             subdomain(k)%IMIN=i-int(subdomain(k)%IRANGE/2)
             subdomain(k)%IMAX= subdomain(k)%IMIN + subdomain(k)%IRANGE -1
             EXIT
           endif
         enddo
       else
         do i=Imin_guess-10, Imin_guess
           if (abs(lons(i)-subdomain(k)%LONGI).LE.cellsizelon/2.D0) then
             subdomain(k)%IMIN=i-int(subdomain(k)%IRANGE/2)
             subdomain(k)%IMAX= subdomain(k)%IMIN + subdomain(k)%IRANGE -1
             EXIT
           endif
         enddo
       endif

       if (abs(lats(Jmin_guess)-subdomain(k)%LATI).LE.cellsizelat/2.D0) then
         subdomain(k)%JMIN=Jmin_guess
       elseif (abs(lats(Jmin_guess+1)-subdomain(k)%LATI).LE.abs(lats(Jmin_guess-1)-subdomain(k)%LATI)) then
         do i=Jmin_guess, Jmin_guess+10
           if (abs(lats(i)-subdomain(k)%LATI).LE.cellsizelat/2.D0) then
             subdomain(k)%JMIN=i-int(subdomain(k)%JRANGE/2)
             subdomain(k)%JMAX= subdomain(k)%JMIN + subdomain(k)%JRANGE -1
             EXIT
           endif
         enddo
       else
         do i=Jmin_guess-10, Jmin_guess
           if (abs(lats(i)-subdomain(k)%LATI).LE.cellsizelat/2.D0) then
             subdomain(k)%JMIN=i-int(subdomain(k)%JRANGE/2)
             subdomain(k)%JMAX= subdomain(k)%JMIN + subdomain(k)%JRANGE -1
             EXIT
           endif
         enddo
        endif
     enddo
     close(20)
  ELSE
     OPEN(UNIT=20,FILE='subdomain_limits.csv')
     DO k=1, num_subdomains
       READ(20,*) subdomain(k)%NOME, subdomain(k)%LATI_LOWERLEFT, subdomain(k)%LONGI_LOWERLEFT, subdomain(k)%LATI_UPPERRIGHT, subdomain(k)%LONGI_UPPERRIGHT
       deltalat=subdomain(k)%LATI_UPPERRIGHT-subdomain(k)%LATI_LOWERLEFT
       deltalon=subdomain(k)%LONGI_UPPERRIGHT-subdomain(k)%LONGI_LOWERLEFT

       print*,deltalat,deltalon
       subdomain(k)%IRANGE=int(deltalon/cellsizelon)
       subdomain(k)%JRANGE=int(deltalat/cellsizelat)
       Imin_guess=int((subdomain(k)%LONGI_LOWERLEFT-lons(1))/cellsizelon)
       Jmin_guess=int((lats(1)-subdomain(k)%LATI_UPPERRIGHT)/cellsizelat)

       if (abs(lons(Imin_guess)-subdomain(k)%LONGI_LOWERLEFT).LE.cellsizelon/2.D0) then
         subdomain(k)%IMIN=Imin_guess
       elseif (abs(subdomain(k)%LONGI_LOWERLEFT-lons(Imin_guess+1)).LE.abs(subdomain(k)%LONGI_LOWERLEFT-lons(Imin_guess-1))) then
         do i=Imin_guess, Imin_guess+10
           if (abs(subdomain(k)%LONGI_LOWERLEFT-lons(i)).LE.cellsizelon/2.D0) then
             subdomain(k)%IMIN=i
             subdomain(k)%IMAX= subdomain(k)%IMIN + subdomain(k)%IRANGE -1
             EXIT
           endif
         enddo
       else
         do i=Imin_guess-10, Imin_guess
           if (abs(subdomain(k)%LONGI_LOWERLEFT-lons(i)).LE.cellsizelon/2.D0) then
             subdomain(k)%IMIN=i
             subdomain(k)%IMAX= subdomain(k)%IMIN + subdomain(k)%IRANGE -1
             EXIT
           endif
         enddo
       endif

       if (abs(lats(Jmin_guess)-subdomain(k)%LATI_UPPERRIGHT).LE.cellsizelat/2.D0) then
         subdomain(k)%JMIN=Jmin_guess
       elseif (abs(lats(Jmin_guess+1)-subdomain(k)%LATI_UPPERRIGHT).LE.abs(lats(Jmin_guess-1)-subdomain(k)%LATI_UPPERRIGHT)) then
         do i=Jmin_guess, Jmin_guess+10
           if (abs(lats(i)-subdomain(k)%LATI_UPPERRIGHT).LE.cellsizelat/2.D0) then
             subdomain(k)%JMIN=i
             subdomain(k)%JMAX= subdomain(k)%JMIN + subdomain(k)%JRANGE -1
             EXIT
           endif
         enddo
       else
         do i=Jmin_guess-10, Jmin_guess
           if (abs(lats(i)-subdomain(k)%LATI_UPPERRIGHT).LE.cellsizelat/2.D0) then
             subdomain(k)%JMIN=i
             subdomain(k)%JMAX= subdomain(k)%JMIN + subdomain(k)%JRANGE -1
             EXIT
           endif
         enddo
        endif
     enddo
     close(20)

  ENDIF



do k=1,num_subdomains
   write(30,*)'!',subdomain(k)%NOME
   write(30,*)'  INTEGER, PARAMETER :: IMIN =',subdomain(k)%IMIN
   write(30,*)'  INTEGER, PARAMETER :: JMIN =',subdomain(k)%JMIN
   write(30,*)'  INTEGER, PARAMETER :: IRANGE =',subdomain(k)%IRANGE
   write(30,*)'  INTEGER, PARAMETER :: JRANGE =',subdomain(k)%JRANGE
   write(30,*)'  INTEGER, PARAMETER :: IMAX =',subdomain(k)%IMAX
   write(30,*)'  INTEGER, PARAMETER :: JMAX =',subdomain(k)%JMAX
end do




   contains
  !!--------------------------------------------
  DOUBLE PRECISION function Nradius(phi)
  !!Radius of curvature in the prime vertical to calculate deltalon
    double precision, intent(in)::phi !in degrees
    DOUBLE PRECISION, PARAMETER :: eq_r=6378137.0, pi=3.1415927,e2=0.00669437999014

    Nradius=eq_r/sqrt(1-e2*(sin(phi*(pi/180.0D0)))**2)
    RETURN
  end function Nradius

  !!--------------------------------------------
  DOUBLE PRECISION function Mradius(phi)
  !!Radius of curvature in the meridian to calculate deltalat
    double precision, intent(in)::phi
    DOUBLE PRECISION, PARAMETER :: eq_r=6378137.0, pi=3.1415927,e2=0.00669437999014

    Mradius=eq_r/sqrt(1-e2*(sin(phi*(pi/180.0D0)))**2)

    RETURN
  end function Mradius
  !!--------------------------------------------
   subroutine check(status)
     integer, intent (in) :: status
     if(status /= nf90_noerr) then
       print *, trim(nf90_strerror(status))
       stop 2
     end if
   end subroutine check
end program
